// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package sessionup

import (
	"context"
	"sync"
)

var (
	lockStoreMockCreate          sync.RWMutex
	lockStoreMockDeleteByID      sync.RWMutex
	lockStoreMockDeleteByUserKey sync.RWMutex
	lockStoreMockFetchByID       sync.RWMutex
	lockStoreMockFetchByUserKey  sync.RWMutex
)

// Ensure, that StoreMock does implement Store.
// If this is not the case, regenerate this file with moq.
var _ Store = &StoreMock{}

// StoreMock is a mock implementation of Store.
//
//     func TestSomethingThatUsesStore(t *testing.T) {
//
//         // make and configure a mocked Store
//         mockedStore := &StoreMock{
//             CreateFunc: func(ctx context.Context, s Session) error {
// 	               panic("mock out the Create method")
//             },
//             DeleteByIDFunc: func(ctx context.Context, id string) error {
// 	               panic("mock out the DeleteByID method")
//             },
//             DeleteByUserKeyFunc: func(ctx context.Context, key string, expID ...string) error {
// 	               panic("mock out the DeleteByUserKey method")
//             },
//             FetchByIDFunc: func(ctx context.Context, id string) (Session, bool, error) {
// 	               panic("mock out the FetchByID method")
//             },
//             FetchByUserKeyFunc: func(ctx context.Context, key string) ([]Session, error) {
// 	               panic("mock out the FetchByUserKey method")
//             },
//         }
//
//         // use mockedStore in code that requires Store
//         // and then make assertions.
//
//     }
type StoreMock struct {
	// CreateFunc mocks the Create method.
	CreateFunc func(ctx context.Context, s Session) error

	// DeleteByIDFunc mocks the DeleteByID method.
	DeleteByIDFunc func(ctx context.Context, id string) error

	// DeleteByUserKeyFunc mocks the DeleteByUserKey method.
	DeleteByUserKeyFunc func(ctx context.Context, key string, expID ...string) error

	// FetchByIDFunc mocks the FetchByID method.
	FetchByIDFunc func(ctx context.Context, id string) (Session, bool, error)

	// FetchByUserKeyFunc mocks the FetchByUserKey method.
	FetchByUserKeyFunc func(ctx context.Context, key string) ([]Session, error)

	// calls tracks calls to the methods.
	calls struct {
		// Create holds details about calls to the Create method.
		Create []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// S is the s argument value.
			S Session
		}
		// DeleteByID holds details about calls to the DeleteByID method.
		DeleteByID []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
		}
		// DeleteByUserKey holds details about calls to the DeleteByUserKey method.
		DeleteByUserKey []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Key is the key argument value.
			Key string
			// ExpID is the expID argument value.
			ExpID []string
		}
		// FetchByID holds details about calls to the FetchByID method.
		FetchByID []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// ID is the id argument value.
			ID string
		}
		// FetchByUserKey holds details about calls to the FetchByUserKey method.
		FetchByUserKey []struct {
			// Ctx is the ctx argument value.
			Ctx context.Context
			// Key is the key argument value.
			Key string
		}
	}
}

// Create calls CreateFunc.
func (mock *StoreMock) Create(ctx context.Context, s Session) error {
	if mock.CreateFunc == nil {
		panic("StoreMock.CreateFunc: method is nil but Store.Create was just called")
	}
	callInfo := struct {
		Ctx context.Context
		S   Session
	}{
		Ctx: ctx,
		S:   s,
	}
	lockStoreMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockStoreMockCreate.Unlock()
	return mock.CreateFunc(ctx, s)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockedStore.CreateCalls())
func (mock *StoreMock) CreateCalls() []struct {
	Ctx context.Context
	S   Session
} {
	var calls []struct {
		Ctx context.Context
		S   Session
	}
	lockStoreMockCreate.RLock()
	calls = mock.calls.Create
	lockStoreMockCreate.RUnlock()
	return calls
}

// DeleteByID calls DeleteByIDFunc.
func (mock *StoreMock) DeleteByID(ctx context.Context, id string) error {
	if mock.DeleteByIDFunc == nil {
		panic("StoreMock.DeleteByIDFunc: method is nil but Store.DeleteByID was just called")
	}
	callInfo := struct {
		Ctx context.Context
		ID  string
	}{
		Ctx: ctx,
		ID:  id,
	}
	lockStoreMockDeleteByID.Lock()
	mock.calls.DeleteByID = append(mock.calls.DeleteByID, callInfo)
	lockStoreMockDeleteByID.Unlock()
	return mock.DeleteByIDFunc(ctx, id)
}

// DeleteByIDCalls gets all the calls that were made to DeleteByID.
// Check the length with:
//     len(mockedStore.DeleteByIDCalls())
func (mock *StoreMock) DeleteByIDCalls() []struct {
	Ctx context.Context
	ID  string
} {
	var calls []struct {
		Ctx context.Context
		ID  string
	}
	lockStoreMockDeleteByID.RLock()
	calls = mock.calls.DeleteByID
	lockStoreMockDeleteByID.RUnlock()
	return calls
}

// DeleteByUserKey calls DeleteByUserKeyFunc.
func (mock *StoreMock) DeleteByUserKey(ctx context.Context, key string, expID ...string) error {
	if mock.DeleteByUserKeyFunc == nil {
		panic("StoreMock.DeleteByUserKeyFunc: method is nil but Store.DeleteByUserKey was just called")
	}
	callInfo := struct {
		Ctx   context.Context
		Key   string
		ExpID []string
	}{
		Ctx:   ctx,
		Key:   key,
		ExpID: expID,
	}
	lockStoreMockDeleteByUserKey.Lock()
	mock.calls.DeleteByUserKey = append(mock.calls.DeleteByUserKey, callInfo)
	lockStoreMockDeleteByUserKey.Unlock()
	return mock.DeleteByUserKeyFunc(ctx, key, expID...)
}

// DeleteByUserKeyCalls gets all the calls that were made to DeleteByUserKey.
// Check the length with:
//     len(mockedStore.DeleteByUserKeyCalls())
func (mock *StoreMock) DeleteByUserKeyCalls() []struct {
	Ctx   context.Context
	Key   string
	ExpID []string
} {
	var calls []struct {
		Ctx   context.Context
		Key   string
		ExpID []string
	}
	lockStoreMockDeleteByUserKey.RLock()
	calls = mock.calls.DeleteByUserKey
	lockStoreMockDeleteByUserKey.RUnlock()
	return calls
}

// FetchByID calls FetchByIDFunc.
func (mock *StoreMock) FetchByID(ctx context.Context, id string) (Session, bool, error) {
	if mock.FetchByIDFunc == nil {
		panic("StoreMock.FetchByIDFunc: method is nil but Store.FetchByID was just called")
	}
	callInfo := struct {
		Ctx context.Context
		ID  string
	}{
		Ctx: ctx,
		ID:  id,
	}
	lockStoreMockFetchByID.Lock()
	mock.calls.FetchByID = append(mock.calls.FetchByID, callInfo)
	lockStoreMockFetchByID.Unlock()
	return mock.FetchByIDFunc(ctx, id)
}

// FetchByIDCalls gets all the calls that were made to FetchByID.
// Check the length with:
//     len(mockedStore.FetchByIDCalls())
func (mock *StoreMock) FetchByIDCalls() []struct {
	Ctx context.Context
	ID  string
} {
	var calls []struct {
		Ctx context.Context
		ID  string
	}
	lockStoreMockFetchByID.RLock()
	calls = mock.calls.FetchByID
	lockStoreMockFetchByID.RUnlock()
	return calls
}

// FetchByUserKey calls FetchByUserKeyFunc.
func (mock *StoreMock) FetchByUserKey(ctx context.Context, key string) ([]Session, error) {
	if mock.FetchByUserKeyFunc == nil {
		panic("StoreMock.FetchByUserKeyFunc: method is nil but Store.FetchByUserKey was just called")
	}
	callInfo := struct {
		Ctx context.Context
		Key string
	}{
		Ctx: ctx,
		Key: key,
	}
	lockStoreMockFetchByUserKey.Lock()
	mock.calls.FetchByUserKey = append(mock.calls.FetchByUserKey, callInfo)
	lockStoreMockFetchByUserKey.Unlock()
	return mock.FetchByUserKeyFunc(ctx, key)
}

// FetchByUserKeyCalls gets all the calls that were made to FetchByUserKey.
// Check the length with:
//     len(mockedStore.FetchByUserKeyCalls())
func (mock *StoreMock) FetchByUserKeyCalls() []struct {
	Ctx context.Context
	Key string
} {
	var calls []struct {
		Ctx context.Context
		Key string
	}
	lockStoreMockFetchByUserKey.RLock()
	calls = mock.calls.FetchByUserKey
	lockStoreMockFetchByUserKey.RUnlock()
	return calls
}
